// #![deny(warnings)]
#[allow(clippy::missing_docs_in_private_items)]

use crate::clouds;
use tokio::fs::File;

use tokio_util::codec::{BytesCodec, FramedRead};

use hyper::service::{make_service_fn, service_fn};
use hyper::{Body, Method, Request, Response, Result, Server, StatusCode};

#[allow(clippy::missing_docs_in_private_items)]
static INDEX: &str = "html/send_file_index.html";
#[allow(clippy::missing_docs_in_private_items)]
static NOTFOUND: &[u8] = b"Not Found";

// https://docs.rs/hyper/0.11.2/hyper/header/struct.Authorization.html
// https://github.com/aramperes/hyper-server-ssl-auth-example/blob/master/src/main.rs
// https://dev.to/deciduously/skip-the-framework-build-a-simple-rust-api-with-hyper-4jf5
/*

#[tokio::main]
pub async fn web_main() -> std::io::Result<()> {  //   Result<()> {
    pretty_env_logger::init();

    let addr = "127.0.0.1:1337".parse().unwrap();

    let make_service =
        make_service_fn(|_| async { Ok::<_, hyper::Error>(service_fn(response_examples)) });

    let server = Server::bind(&addr).serve(make_service);

    println!("Listening on http://{}", addr);

    if let Err(e) = server.await {
        eprintln!("server error: {}", e);
    }
   Ok(())
}
*/
#[allow(clippy::missing_docs_in_private_items)]
pub async fn response_examples(req: Request<Body>) -> Result<Response<Body>> {
    match (req.method(), req.uri().path()) {
        (&Method::GET, "/") | (&Method::GET, "/index.html") => simple_file_send(INDEX).await,
        (&Method::GET, "/y") | (&Method::GET, "/yaml.html") => data_file_send().await,
        (&Method::GET, "/no_file.html") => {
            // Test what happens when file cannot be be found
            simple_file_send("this_file_should_not_exist.html").await
        }
        _ => Ok(not_found()),
    }
}

/// HTTP status code 404
#[allow(clippy::missing_docs_in_private_items,clippy::unwrap_used)]
fn not_found() -> Response<Body> {
    Response::builder()
        .status(StatusCode::NOT_FOUND)
        .body(NOTFOUND.into())
        .unwrap()
}

#[allow(clippy::missing_docs_in_private_items)]
pub async fn simple_file_send(filename: &str) -> Result<Response<Body>> {
    // Serve a file by asynchronously reading it by chunks using tokio-util crate.

    if let Ok(file) = File::open(filename).await {
        let stream = FramedRead::new(file, BytesCodec::new());
        let body = Body::wrap_stream(stream);
        return Ok(Response::new(body));
    }

    Ok(not_found())
}

#[allow(clippy::missing_docs_in_private_items)]
pub async fn data_file_send() -> Result<Response<Body>> {
    // Serve a file by asynchronously reading it by chunks using tokio-util crate.

    // if let Ok(file) = File::open(filename).await {
    //     let stream = FramedRead::new(file, BytesCodec::new());
    //     let body = Body::wrap_stream(stream);
    match  clouds::on_cloud("createserver", "test","install","","", 1).await {
      Ok(data) => Ok(Response::new(Body::from(data))),
      Err(_) =>Ok(Response::new(Body::from("Error")))
    }
}